//=====================================================================
//	  :
//=====================================================================
#property copyright		"Dima S., 2012"
#property link				"dimascub@mail.ru"
#property version			"1.07"
#property description	"  "
#property description	"(    )"
//---------------------------------------------------------------------

//=====================================================================
//	 :
//=====================================================================
//	29.12.2010. - V1.00
//	 -  ;
//
//	11.01.2011. - V1.01
//	 -  -   ;
//	 -  -       ;
//	 -  -      
//		 (  - );
//
//	13.01.2011. - V1.02
//	 -  -          ;
//
//	14.01.2011. - V1.03
//	 -  -        
//		      ;
//	 -  -    ;
//
//	21.01.2011. - V1.04
//	 -  -    ;
//	 -  -    ;
//
//	27.01.2011. - V1.05
//	 -  -    (      );
//
//	08.02.2011. - V1.06
//	 -  -       
//		    DRAW_COLOR_SECTION;
//
//	02.04.2012. - V1.07
//	 -  -        ,
//		   ;
//
//---------------------------------------------------------------------


//=====================================================================
//	 :
//=====================================================================
#include	<ChartObjects\ChartObjectsArrows.mqh>
#include  <TextDisplay.mqh>
//---------------------------------------------------------------------


//---------------------------------------------------------------------
#property indicator_chart_window
//---------------------------------------------------------------------
#property	indicator_buffers		2
#property indicator_plots			1
#property indicator_type1			DRAW_COLOR_SECTION
#property indicator_color1		LightGreen, LightPink
#property indicator_width1		5
//---------------------------------------------------------------------

//=====================================================================
//	  :
//=====================================================================
input int				MaxBars = 1000;
input bool			IsSaveTrendParams = true;
//---------------------------------------------------------------------
input bool			ShowInfo = true;
input int				UpDownInfoShift = 21;
input int				LeftRightInfoShift = 1;
input color			TitlesColor = LightCyan;
input color			TopFieldsColor = LightGreen;
input color			LowFieldsColor = LightPink;
//---------------------------------------------------------------------
input color			UpStopLossColor = LightGreen;
input color			DnStopLossColor = LightPink;
input int				StopLossWidth = 3;
//---------------------------------------------------------------------

//---------------------------------------------------------------------
#define	FONTSIZE	10
//---------------------------------------------------------------------

//---------------------------------------------------------------------
string				prefix = "GannMainTrend";
CList*				up_list_Ptr = NULL;																			//  
CList*				dn_list_Ptr = NULL;																			//  
TableDisplay*	info_display_Ptr;																				//        
//---------------------------------------------------------------------
int				trend_dir = 0;																							//   ( 1 - , -1 - , 0 -   )
int				active_bar;																									//   
int				last_top_bar = -1;																					//   
int				last_low_bar = -1;																					//   
//---------------------------------------------------------------------
string		InfoTitles_Array[ ] = { "Last Main Top:", "Last Main Low:" };
//---------------------------------------------------------------------

//---------------------------------------------------------------------
//	 :
//---------------------------------------------------------------------
double		DataBuffer[ ];
double		ColorBuffer[ ];
//---------------------------------------------------------------------

//---------------------------------------------------------------------
//	  :
//---------------------------------------------------------------------
int
OnInit( )
{
	up_list_Ptr = new CList( );
	if( CheckPointer( up_list_Ptr ) != POINTER_DYNAMIC )
	{
		Print( "   CList #1" );
		return( -1 );
	}

	dn_list_Ptr = new CList( );
	if( CheckPointer( dn_list_Ptr ) != POINTER_DYNAMIC )
	{
		Print( "   CList #2" );
		return( -1 );
	}

	if( InitGraphObjects( ) != 0 )
	{
		Print( "   TableDisplay" );
		return( -1 );
	}

	SetIndexBuffer( 0, DataBuffer, INDICATOR_DATA );
	SetIndexBuffer( 1, ColorBuffer, INDICATOR_COLOR_INDEX );

	IndicatorSetInteger( INDICATOR_DIGITS, Digits( ));
	IndicatorSetString( INDICATOR_SHORTNAME, "GannMainTrend" );
	PlotIndexSetString( 0, PLOT_LABEL, "GannMainTrend" );
	PlotIndexSetDouble( 0, PLOT_EMPTY_VALUE, 0.0 );

	ChartRedraw( );
	return( 0 );
}

//---------------------------------------------------------------------
//	   :
//---------------------------------------------------------------------
void
OnDeinit( const int _reason )
{
	DeleteGraphObjects( );
	ChartRedraw( );
}

//---------------------------------------------------------------------
//	   :
//---------------------------------------------------------------------
int
OnCalculate( const int rates_total, const int prev_calculated, const datetime& time[ ], const double& open[ ], const double& high[ ], const double& low[ ], const double& close[ ], const long& tick_volume[ ], const long& volume[ ], const int& spread[ ] )
{
	int		start;

	if( prev_calculated == 0 )
	{
		ArrayInitialize( DataBuffer, 0.0 );

		if( CheckPointer( up_list_Ptr ) != POINTER_INVALID )
		{
			up_list_Ptr.Clear( );
		}
		if( CheckPointer( dn_list_Ptr ) != POINTER_INVALID )
		{
			dn_list_Ptr.Clear( );
		}

//	    :
		if( MaxBars > 0 && rates_total > MaxBars )
		{
			start = rates_total - MaxBars + 3;
		}
		else
		{
			start = 3;
		}
		trend_dir = 0;						//   ( 1 - , -1 - , 0 -   )
	}
	else
	{
		start = prev_calculated - 1;
	}

//	 :
	for( int i = start; i < rates_total; i++ )
	{
//	      ,         :
		if( trend_dir == 0 )
		{
			if( high[ i ] > high[ i - 1 ] && high[ i - 1 ] > high[ i - 2 ] && high[ i - 2 ] > high[ i - 3 ] /*&& low[ i ] > low[ index - 1 ] && low[ index - 1 ] > low[ index - 2 ]*/ )
			{
				trend_dir = 1;
				active_bar = i;
			}
			else if( /*high[ i ] < high[ i - 1 ] && high[ i - 1 ] < high[ i - 2 ] &&*/ low[ i ] < low[ i - 1 ] && low[ i - 1 ] < low[ i - 2 ] && low[ i - 2 ] < low[ i - 3 ] )
			{
				trend_dir = -1;
				active_bar = i;
				last_top_bar = -1;
				last_low_bar = -1;
			}
			continue;
		}

//---------------------------------------------------------------------
//	 :
		if( trend_dir == 1 )
		{
//	   :
			if( high[ i ] > high[ active_bar ] )
			{
				ColorBuffer[ active_bar ] = 0;
				DataBuffer[ active_bar ] = high[ active_bar ];

				ColorBuffer[ i ] = 0;
				DataBuffer[ i ] = high[ i ];

				active_bar = i;

				continue;
			}

//	    :
			if( low[ i ] < low[ i - 1 ] && low[ i - 1 ] < low[ i - 2 ] && low[ i - 2 ] < low[ active_bar ] )
			{
				ColorBuffer[ active_bar ] = 0;
				DataBuffer[ active_bar ] = high[ active_bar ];

				ColorBuffer[ i ] = 1;
				DataBuffer[ i ] = low[ i ];

				CreateUpStopLoss( time[ active_bar ], high[ active_bar ], UpStopLossColor, StopLossWidth );
				SaveUpStopLossParams( time[ active_bar ], high[ active_bar ] );

				trend_dir = -1;
				SaveTrendParams( trend_dir, time[ i ] );

				last_top_bar = active_bar;
				last_low_bar = -1;
				active_bar = i;

				continue;
			}

//	     ,   :
			if( last_low_bar != -1 && low[ i ] < low[ last_low_bar ] )
			{
				ColorBuffer[ active_bar ] = 0;
				DataBuffer[ active_bar ] = high[ active_bar ];

				ColorBuffer[ i ] = 1;
				DataBuffer[ i ] = low[ i ];

				CreateUpStopLoss( time[ active_bar ], high[ active_bar ], UpStopLossColor, StopLossWidth );
				SaveUpStopLossParams( time[ active_bar ], high[ active_bar ] );

				trend_dir = -1;
				SaveTrendParams( trend_dir, time[ i ] );

				last_top_bar = active_bar;
				last_low_bar = -1;
				active_bar = i;

				continue;
			}
		}

//---------------------------------------------------------------------
//	 :
		if( trend_dir == -1 )
		{
//	   :
			if( low[ i ] < low[ active_bar ] )
			{
				ColorBuffer[ active_bar ] = 1;
				DataBuffer[ active_bar ] = low[ active_bar ];

				ColorBuffer[ i ] = 1;
				DataBuffer[ i ] = low[ i ];

				active_bar = i;

				continue;
			}

//	    :
			if( high[ i ] > high[ i - 1 ] && high[ i - 1 ] > high[ i - 2 ] && high[ i - 2 ] > high[ active_bar ] )
			{
				ColorBuffer[ active_bar ] = 1;
				DataBuffer[ active_bar ] = low[ active_bar ];

				ColorBuffer[ i ] = 1;
				DataBuffer[ i ] = high[ i ];

				CreateDnStopLoss( time[ active_bar ], low[ active_bar ], DnStopLossColor, StopLossWidth );
				SaveDnStopLossParams( time[ active_bar ], low[ active_bar ] );

				trend_dir = 1;
				SaveTrendParams( trend_dir, time[ i ] );

				last_low_bar = active_bar;
				last_top_bar = -1;
				active_bar = i;

				continue;
			}

//	     ,   :
			if( last_top_bar != -1 && high[ i ] > high[ last_top_bar ] )
			{
				ColorBuffer[ active_bar ] = 1;
				DataBuffer[ active_bar ] = low[ active_bar ];

				ColorBuffer[ i ] = 1;
				DataBuffer[ i ] = high[ i ];

				CreateDnStopLoss( time[ active_bar ], low[ active_bar ], DnStopLossColor, StopLossWidth );
				SaveDnStopLossParams( time[ active_bar ], low[ active_bar ] );

				trend_dir = 1;
				SaveTrendParams( trend_dir, time[ i ] );

				last_low_bar = active_bar;
				last_top_bar = -1;
				active_bar = i;

				continue;
			}
		}
	}

//	  ,        :
	if( ShowInfo == true )
	{
		if( up_list_Ptr.Total( ) > 0 )
		{
			CChartObjectArrowRightPrice*	up_obj = ( CChartObjectArrowRightPrice* )( up_list_Ptr.GetLastNode( ));
			if(( PeriodSeconds( ) / 60 ) >= 1440 )
			{
				info_display_Ptr.SetText( 0, DoubleToString( up_obj.Price( 0 ), Digits( )) + "  ( " + TimeToString( up_obj.Time( 0 ), TIME_DATE ) + " )");
			}
			else
			{
				info_display_Ptr.SetText( 0, DoubleToString( up_obj.Price( 0 ), Digits( )) + "  ( " + TimeToString( up_obj.Time( 0 )) + " )");
			}
		}
		if( dn_list_Ptr.Total( ) > 0 )
		{
			CChartObjectArrowLeftPrice*	dn_obj = ( CChartObjectArrowLeftPrice* )( dn_list_Ptr.GetLastNode( ));
			if(( PeriodSeconds( ) / 60 ) >= 1440 )
			{
				info_display_Ptr.SetText( 1, DoubleToString( dn_obj.Price( 0 ), Digits( )) + "  ( " + TimeToString( dn_obj.Time( 0 ), TIME_DATE ) + " )" );
			}
			else
			{
				info_display_Ptr.SetText( 1, DoubleToString( dn_obj.Price( 0 ), Digits( )) + "  ( " + TimeToString( dn_obj.Time( 0 )) + " )" );
			}
		}
	}

	return( rates_total );
}

//---------------------------------------------------------------------
//	  :
//---------------------------------------------------------------------
int
InitGraphObjects( )
{
	if( ShowInfo == true )
	{
		info_display_Ptr = new TableDisplay( 0, 0 );
		if( CheckPointer( info_display_Ptr ) != POINTER_DYNAMIC )
		{
			return( -1 );
		}
		info_display_Ptr.AddFieldObject( LeftRightInfoShift + 10, UpDownInfoShift + 0 * 3 + 8, TopFieldsColor, ANCHOR_LEFT, FONTSIZE, "Arial", CORNER_LEFT_UPPER );
		info_display_Ptr.AddFieldObject( LeftRightInfoShift + 10, UpDownInfoShift + 1 * 3 + 8, LowFieldsColor, ANCHOR_LEFT, FONTSIZE, "Arial", CORNER_LEFT_UPPER );

//	:
		for( int k = 0; k < 2; k++ )
		{
			info_display_Ptr.AddTitleObject( LeftRightInfoShift + 9, UpDownInfoShift + k * 3 + 8, InfoTitles_Array[ k ], TitlesColor, ANCHOR_RIGHT, FONTSIZE, "Arial", CORNER_LEFT_UPPER );
		}
	}

	return( 0 );
}

//---------------------------------------------------------------------
//	  :
//---------------------------------------------------------------------
void
DeleteGraphObjects( )
{
	if( CheckPointer( up_list_Ptr ) == POINTER_DYNAMIC )
	{
		delete( up_list_Ptr );
	}

	if( CheckPointer( dn_list_Ptr ) == POINTER_DYNAMIC )
	{
		delete( dn_list_Ptr );
	}

	if( CheckPointer( info_display_Ptr ) == POINTER_DYNAMIC )
	{
		delete( info_display_Ptr );
	}
}

//---------------------------------------------------------------------
//	     :
//---------------------------------------------------------------------
void
SaveTrendParams( int _dir, datetime _dt )
{
	if( IsSaveTrendParams == true )
	{
		string	name = prefix + "_" + Symbol( ) + "_" + IntegerToString( PeriodSeconds( ) / 60 ) + "_Dir";
		GlobalVariableSet( name, _dir );
		GlobalVariableSet( name + "_DTime", _dt );
	}
}

//---------------------------------------------------------------------
//	    (   )   :
//---------------------------------------------------------------------
void
SaveUpStopLossParams( datetime _dt, double _price )
{
	if( IsSaveTrendParams == true )
	{
		string	name = prefix + "_" + Symbol( ) + "_" + IntegerToString( PeriodSeconds( ) / 60 ) + "_UpSL";
		GlobalVariableSet( name + "_DTime", _dt );
		GlobalVariableSet( name + "_Price", _price );
	}
}

//---------------------------------------------------------------------
//	    (   )   :
//---------------------------------------------------------------------
void
SaveDnStopLossParams( datetime _dt, double _price )
{
	if( IsSaveTrendParams == true )
	{
		string	name = prefix + "_" + Symbol( ) + "_" + IntegerToString( PeriodSeconds( ) / 60 ) + "_DnSL";
		GlobalVariableSet( name + "_DTime", _dt );
		GlobalVariableSet( name + "_Price", _price );
	}
}

//---------------------------------------------------------------------
//	    (   ):
//---------------------------------------------------------------------
void
CreateUpStopLoss( datetime _dt, double _price, color _clr, int _wd )
{
	if( ShowInfo == true )
	{
		string	name = GetUniqName( prefix + " " );
		CChartObjectArrowRightPrice*	up_obj = new CChartObjectArrowRightPrice( );
		if( CheckPointer( up_obj ) != POINTER_INVALID )
		{
			up_obj.Create( 0, name, 0, _dt, _price );
			up_obj.Color( _clr );
			up_obj.Width( _wd );
			up_list_Ptr.Add( up_obj );
		}
	}
}

//---------------------------------------------------------------------
//	    (   ):
//---------------------------------------------------------------------
void
CreateDnStopLoss( datetime _dt, double _price, color _clr, int _wd )
{
	if( ShowInfo == true )
	{
		string	name = GetUniqName( prefix + " " );
		CChartObjectArrowLeftPrice*	dn_obj = new CChartObjectArrowLeftPrice( );
		if( CheckPointer( dn_obj ) != POINTER_INVALID )
		{
			dn_obj.Create( 0, name, 0, _dt, _price );
			dn_obj.Color( _clr );
			dn_obj.Width( _wd );
			dn_list_Ptr.Add( dn_obj );
		}
	}
}

//---------------------------------------------------------------------
//	  :
//---------------------------------------------------------------------
string
GetUniqName( string _prefix = "" )
{
	static uint	prev_count = 0;

	uint			count = GetTickCount( );
	while( 1 )
	{
		if( prev_count == UINT_MAX )
		{
			prev_count = 0;
		}
		if( count <= prev_count )
		{
			prev_count++;
			count = prev_count;
		}
		else
		{
			prev_count = count;
		}

//	,       :
		string		name = _prefix + TimeToString( TimeGMT( ), TIME_DATE | TIME_MINUTES | TIME_SECONDS ) + " " + DoubleToString( count, 0 );
		if( ObjectFind( 0, name ) < 0 )
		{
			return( name );
		}
	}

	return( NULL );
}
//---------------------------------------------------------------------
